diff --git a/devlink/devlink.c b/devlink/devlink.c
index f999e5940c63..dbeb6e397e8e 100644
--- a/devlink/devlink.c
+++ b/devlink/devlink.c
@@ -2329,7 +2329,7 @@ static int dl_argv_dry_parse(struct dl *dl, uint64_t o_required,
 	return err;
 }
 
-/* List of extented handles with two slashes. */
+/* List of extended handles with two slashes. */
 static const uint64_t dl_opt_extended_handle[] = {
 	DL_OPT_HANDLEP,
 	DL_OPT_HANDLE_REGION,
diff --git a/examples/bpf/README b/examples/bpf/README
index b7261191fc1e..4c27bb4e8cbe 100644
--- a/examples/bpf/README
+++ b/examples/bpf/README
@@ -15,4 +15,4 @@ with syntax and features:
 
 Note: Users should use new BTF way to defined the maps, the examples
 in legacy folder which is using struct bpf_elf_map defined maps is not
-recommanded.
+recommended.
diff --git a/lib/json_print.c b/lib/json_print.c
index 7b3b6c3fafba..810d496e99c7 100644
--- a/lib/json_print.c
+++ b/lib/json_print.c
@@ -217,7 +217,7 @@ int print_color_bool(enum output_type type,
 
 /* In JSON mode, acts like print_color_bool.
  * Otherwise, will print key with prefix of "no" if false.
- * The show flag is used to suppres printing in non-JSON mode
+ * The show flag is used to suppress printing in non-JSON mode
  */
 int print_color_bool_opt(enum output_type type,
 			 enum color_attr color,
diff --git a/lib/utils.c b/lib/utils.c
index 599e859ea393..6c1c1a8d31fd 100644
--- a/lib/utils.c
+++ b/lib/utils.c
@@ -1582,7 +1582,7 @@ size_t strlcat(char *dst, const char *src, size_t size)
 void drop_cap(void)
 {
 #ifdef HAVE_LIBCAP
-	/* don't harmstring root/sudo */
+	/* don't hamstring root/sudo */
 	if (getuid() != 0 && geteuid() != 0) {
 		cap_t capabilities;
 		cap_value_t net_admin = CAP_NET_ADMIN;
diff --git a/rdma/rdma.h b/rdma/rdma.h
index 1f8f83269457..df1852db5928 100644
--- a/rdma/rdma.h
+++ b/rdma/rdma.h
@@ -40,7 +40,7 @@ struct filter_entry {
 	char *key;
 	char *value;
 	/*
-	 * This field means that we can try to issue .doit calback
+	 * This field means that we can try to issue .doit callback
 	 * on value above. This value can be converted to integer
 	 * with simple atoi(). Otherwise "is_doit" will be false.
 	 */
diff --git a/tc/em_canid.c b/tc/em_canid.c
index 6d06b66a5944..228547529134 100644
--- a/tc/em_canid.c
+++ b/tc/em_canid.c
@@ -26,7 +26,7 @@
 #include <inttypes.h>
 #include "m_ematch.h"
 
-#define EM_CANID_RULES_MAX 400 /* Main reason for this number is Nelink
+#define EM_CANID_RULES_MAX 400 /* Main reason for this number is Netlink
 	message size limit equal to Single memory page size. When dump()
 	is invoked, there are even some ematch related headers sent from
 	kernel to userspace together with em_canid configuration --
diff --git a/tc/m_gact.c b/tc/m_gact.c
index e294a701bfd1..225ffce41412 100644
--- a/tc/m_gact.c
+++ b/tc/m_gact.c
@@ -18,7 +18,7 @@
 #include "tc_util.h"
 #include <linux/tc_act/tc_gact.h>
 
-/* define to turn on probablity stuff */
+/* define to turn on probability stuff */
 
 #ifdef CONFIG_GACT_PROB
 static const char *prob_n2a(int p)
diff --git a/tc/q_htb.c b/tc/q_htb.c
index 63b9521b89de..9afb293d9455 100644
--- a/tc/q_htb.c
+++ b/tc/q_htb.c
@@ -224,7 +224,7 @@ static int htb_parse_class_opt(struct qdisc_util *qu, int argc, char **argv,
 	opt.ceil.rate = (ceil64 >= (1ULL << 32)) ? ~0U : ceil64;
 
 	/* compute minimal allowed burst from rate; mtu is added here to make
-	   sute that buffer is larger than mtu and to have some safeguard space */
+	   sure that buffer is larger than mtu and to have some safeguard space */
 	if (!buffer)
 		buffer = rate64 / get_hz() + mtu;
 	if (!cbuffer)
diff --git a/tipc/README b/tipc/README
index 578a0b7b58a7..529d7814f125 100644
--- a/tipc/README
+++ b/tipc/README
@@ -13,10 +13,10 @@ possible to create a vlan named "help" with the ip tool, but it's impossible
 to remove it, the command just shows help. This is an effect of treating
 bare words specially.
 
-Help texts are not dynamically generated. That is, we do not pass datastructures
+Help texts are not dynamically generated. That is, we do not pass data structures
 like command list or option lists and print them dynamically. This is
 intentional. There is always that exception and when it comes to help texts
-these exceptions are normally neglected at the expence of usability.
+these exceptions are normally neglected at the expense of usability.
 
 KEY-VALUE
 ~~~~~~~~~